<template>
  <div class='table-box'>
    <ProTable
      ref='proTable'
      :columns='columns'
      :request-api="getTableList"
    >
      <!-- :requestApi="getRoleList" -->
      <!-- 表格 header 按钮 -->
      <template #tableHeader='scope'>
        <el-button type='primary' :icon='CirclePlus' @click="openDrawer('新增角色')">新增</el-button>
                <el-button type='danger' :icon='Delete' plain :disabled='!scope.isSelected'
                   @click='batchDelete(scope.selectedListIds)'>
          批量删除
        </el-button>
      </template>
      <!-- 表格操作 -->
      <template #operation='scope'>
        <el-button type='primary' link :icon='EditPen' @click="openDrawer('编辑角色', scope.row)">编辑</el-button>
        <el-button type='primary' link :icon='Delete' @click='deleteAccount(scope.row)'>删除</el-button>
        <el-button type='primary' link :icon='Share' @click="openDrawer('设置权限', scope.row)">设置权限</el-button>
      </template>

    </ProTable>
  </div>
  <RolePopup :refresh-table='proTable?.getTableList' ref='rolePopup' />
  <RoleResourcePopup :refresh-table='proTable?.getTableList' ref='roleResourcePopup' />
</template>

<script setup lang='tsx' name='useRole'>
import { type Role } from '@/api/role/interface'
import { type Function } from '@/api/function/interface'
import { useHandleData } from '@/hooks/useHandleData'
import ProTable from '@/components/ProTable/index.vue'
import type{  ProTableInstance, ColumnProps } from '@/components/ProTable/interface'
import { CirclePlus, Delete, EditPen, Share, Download, Upload, View, Refresh } from '@element-plus/icons-vue'
import {getRoleList,deleteRole,getFunctionList} from '@/api/role/role'
import RolePopup from './components/rolePopup.vue'
import RoleResourcePopup from './components/roleResourcePopup.vue'
import { onMounted, reactive, ref } from 'vue'
import {useDictStore} from '@/stores/modules/dict'
const rolePopup = ref()
const roleResourcePopup = ref()
const dictStore = useDictStore()
// ProTable 实例
const proTable = ref<ProTableInstance>()
const functionList = ref<Function.ResFunction[]>([])
// 如果你想在请求之前对当前请求参数做一些操作，可以自定义如下函数：params 为当前所有的请求参数（包括分页），最后返回请求列表接口
// 默认不做操作就直接在 ProTable 组件上绑定	:requestApi="getUserList"
const getTableList = (params: any) => {
  let newParams = JSON.parse(JSON.stringify(params))
  newParams.createTime && (newParams.startTime = newParams.createTime[0])
  newParams.createTime && (newParams.endTime = newParams.createTime[1])
  delete newParams.createTime
  return getRoleList(newParams)
}


  // 初始化时获取角色列表
  onMounted(async () => {
    const response = await getFunctionList()
    functionList.value = response.data as unknown as Function.ResFunction[]
    //console.log(functionList.value)
  })

// 表格配置项
const columns = reactive<ColumnProps<Role.RoleBO>[]>([
  { type: 'selection', fixed: 'left', width: 70 },
  { type: 'index', fixed: 'left', width: 70, label: '序号' },
  {
    prop: 'name',
    label: '名称',
    search: { el: 'input' },
    minWidth: 150,
  },
  {
    prop: 'code',
    label: '编码',
    search: { el: 'input' },
    minWidth: 200,
  },
  {
    prop: 'remark',
    label: '描述',
    minWidth: 300,
  },
  {
    prop: 'state',
    label: '状态',
    minWidth: 100,
      render: scope => {
        return (
          <el-tag type={scope.row.state ? 'success' : 'danger'} > {scope.row.state ? '正常' : '删除'} </el-tag>
        )
      },
  },
  { prop: 'operation', label: '操作', fixed: 'right', width: 250 },
])

// 删除角色信息
const deleteAccount = async (params: Role.RoleBO) => {
  if (params.id) {
  await useHandleData(deleteRole, [params.id], '删除所选角色信息')
  proTable.value?.clearSelection()
  proTable.value?.getTableList()
  }
}

// 批量删除角色信息
const batchDelete = async (id: string[]) => {
  await useHandleData(deleteRole, id , '删除所选角色信息')
  proTable.value?.clearSelection()
  proTable.value?.getTableList()
}


// 打开 drawer(新增、查看、编辑)
const openDrawer = (titleType: string, row: Partial<Role.RoleBO> = {}) => {
    if(titleType==='设置权限'){
      roleResourcePopup.value?.open(titleType, row,functionList.value)
     }else{
       rolePopup.value?.open(titleType, row)
     }
}
</script>
  